package LATMOS::Accounts::Web::Controller::Json::RefVal;
use Moose;
use namespace::autoclean;

BEGIN { extends 'Catalyst::Controller'; }

=head1 NAME

LATMOS::Accounts::Web::Controller::Json::RefVal - Catalyst Controller

=head1 DESCRIPTION

Catalyst Controller.

=head1 METHODS

=cut


=head2 index

=cut

sub index :Path :Args(2) {
    my ( $self, $c, $otype, $attr ) = @_;

    my $base = $c->model('Accounts')->db;

    my $attribute = $base->attribute($otype, $attr);
    my $term = $c->req->param('term') || '';

    my @values = $attribute->can_values;

    if (my $oref = $attribute->reference) {
        if ($term) {
            my %objs = ();
            foreach my $attr (@{ $c->config->{objects}{$oref}{quick_search} || [ 'cn' ]}) {
                warn $attr;
                foreach ($base->search_objects(
                        $oref, "$attr~" . $term)) {
                    $objs{$_} = 1;
                }
            }
            @values = grep { $objs{$_} } @values;
        }

        if (scalar(@values) <= 20) {
            $c->stash->{data} = [
                map { my $o = $base->get_object($attribute->reference, $_); { label => "$o", value => $_ } }
                @values ];
        } else {
            $c->stash->{data} = [ map { { label => $_, value => $_ } } @values ];
        }
    } else {
        $c->stash->{data} = [ map { { label => $_, value => $_ } } grep { $_ =~ /\Q$term\E/i } @values ];
    }
}



=encoding utf8

=head1 AUTHOR

olivier

=head1 LICENSE

This library is free software. You can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

__PACKAGE__->meta->make_immutable;

1;
